// cdm.cpp
// This proggie will be used to test and develop the cellphone dictionary creating proggie and functions. When happy, modify it to be the main version

#include "cdm.h"
#include <vector>
#include <fstream>
#include <iostream>
#include "../oformat.h"
using namespace std;

int main ()	{
	vector<string> txt;
	vector<string> dict;
	vector<string> dicte;
	vector<string> dicts;
	vector<string> dictsa;
	string word, wordplus, filename, dictname;
	bool wordexists = false;
	bool textexists = true;
	wordchanger	w;
	char* wp;
	string q;



	cout << "**********************************************************************\n"
		 << "*                                                                    *\n"
		 << "*                   CELLPHONE DICTIONARY MAKER                       *\n"
		 << "*           This program is freeware. The source code and            *\n"
		 << "*           the program can be used acording to the terms of         *\n"
		 << "*                     	 GNU GPL license.                            *\n"
		 << "*                    www.tkoletivrijedi.in.rs                        *\n"
		 << "**********************************************************************\n"
		 << "\nHello :)\n\n"
		 << "This is a program that will create a file containing a wordlist that\n"
		 << "can be used as Your cell phone dictionary out of any text file. You\n"
		 << "will need to place the text file, UTF- 8 encoded, in the same folder\n"
		 << "in which this executable resides. You can provide an UTF- 8 encoded\n"
		 << "file by opening any text file in a text editor, a book downloaded from\n"
		 << "the gutenberg.org website for instance, then selecting UTF- 8 encoding\n"
		 << "in the user interface, and saving it to disk. The most fun with the least\n"
		 << "problems will be had if the filename doesn't contain spaces and if it's\n"
		 << "typed with no path(IE textfile.txt).\n\n"
		 << "Please enter the name of the text file You wish to convert:";



	md(2);
	getline(cin, filename, '\n');
	const char* fn= &filename[0];
	md(2);
	ifstream in(fn);
//	assert(in >> word);
	if(!(in >> word))	{
		md(5);
		cout << "\n\nThe file specified doesn't exist in this folder, or the file is empty!\n"
			 << "Please make sure that the file specified exists, that it contains text, and\n"
			 << "run this program again.\n\n";
		textexists = false;
		goto bot;
	}	
	while(in >> word)
		txt.push_back(word);
		
		
// This section asks the user whether one wishes to append an existing dictionary and does as told
	md(5);
	cout << "Do You wish to append an existing dictionary with the contents\n"
		 << "of the text file You selected (enter 'y' if You wish to do so)?\n";
		 getline(cin, q, '\n');
		 if(q == "y")	{
		 	md(2);
		 	cout << "Please enter the name of the dictionary file You wish to append to:\n\n";
			getline(cin, dictname, '\n');
			const char* dn= &dictname[0];
			md(2);
			ifstream din(dn);
//			assert (din >> word);
			if(!(din >> word))	{
				md(5);
				cout << "\n\nThe file specified doesn't exist in this folder, or the file is empty!\n"
					 << "Please make sure that the file specified exists, that it contains text, and\n"
					 << "run this program again.\n\n";
				textexists = false;
				goto bot;
			}	
			while(din >> word)
				txt.push_back(word);		 	
		 }
// End of section


// This section determines the size of a string! There's a function that can do that, but someone didn't want to look...
	for(int i = 0; i < txt.size(); i++)	{
		word = txt[i];
		wordplus = word + '~';
		int sz = 0;
		while (wordplus[sz] != '~')
			sz++;
// End of section!
		
// This section eliminates hyphenated words
		if(txt[i][sz-1] == 45)	{
			txt[i] = "1";
			txt[i+1] = "1";
			word = txt[i];
			sz = 1;
		}
// End of section		
		
// This section invokes the functions necessary to change all the characters to lower case, replace all the special signs and numbers with spaces,
// cap the string if there's a space in the end and test if the string is broken, i.e. whether there are spaces somewhere in the middle
		wp = &word[0];
		if(sz > 3)
			w.changeword(wp, sz);
		if(word[sz - 1] == ' ')	{															// Test for the character before last one in the string because the last one is always the NULL character!
			word.resize(sz - 1);															// Cap the word if there's a white space in the end!
			sz -= 1;																		// Reduce the size variable apropriately. This is done because special signs at the end of a word are replaced by spaces.
		}
		if(!w.testword(wp, sz) && sz > 3)								
			dict.push_back(word);
	}
// End of section!	

	cout << endl << dict.size() << " words found!\n\n";
	cout << "Eliminating duplicate words...\n\n";
	md(2);
	dicte.push_back(dict[1]);																					// Because Unicode texts start with a special character that appends itself to the start of the first word, the first member of the vector will be omitted
	for(int i = 2; i < dict.size(); i++)	{
		for(int j = 0; j < dicte.size(); j++)	{
			word = dict[i];
			wordplus = dicte[j];
			if(word == wordplus)	{
				wordexists = true;
				break;			
			};
		};
		if(!wordexists && word[0] != '\0' && word[0] != 32)	{
			dicte.push_back(word);
		};
		wordexists = false;
		};
	md(2);
	cout << "Sorting...";
	md(2);
	for(int i = 0; i < dicte.size(); i++)	{
		int k = 0;
		word = "a";	
			for(int j = 0; j < dicte.size(); j++)	{
				if(dicte[j] > word)
					word = dicte[j];
			};
			while(dicte[k] != word)
				++k;
			dicte[k] = "a";
			dicts.push_back(word);
	};
	for(int i = 0; i < dicts.size(); i++)
		dictsa.push_back(dicts[dicts.size() - 1 - i]);
// End of the sorting bit!
			
	cout << "After eliminating duplicate words and sorting " << dicts.size() << " words remain." << endl;
	
//	pressc();
	bot:
	if(textexists)	{
	ofstream out("wordlist.txt");
	md(2);	
	cout << "Dumping the words into the file wordlist.txt which can be found\n"
		 << "in the same folder in which this executable resides...";
	md(2);
	for(int i = 0; i < dictsa.size(); i++)
		out << dictsa[i] << '\n';
	pressc();
	md(20);
	cout << "Please open the wordlist.txt file created in the folder in which\n"
		 << "this executable resides in a text editor, such as Notepad, and\n"
	     << "remove any punctuation characters the program didn't filter out.\n"
	 	 << "Also, review the words in the file and remove words that are misspelt,\n"
	 	 << "and save the file to disk encoded as UTF- 8.\n\n"
		 << "Once done, You can use the User Dictionary Manager to import the file\n"
		 << "into an Android user autocorrection dictionary for the desired language.\n"
		 << "From that point on, the phone will suggest corrections while typing.\n"
		 << "I don't know whether apps such as the User Dictionary Manager exist\n"
		 << "for Windows mobile phones and iOS, but maybe something can be found.\n\n\n"
		 << "Cordially,\n"
		 << "Leo";
	md(5);
	}
	pressc();
}	///:~


